;==============================================================================
    include \masm32\include\masm32rt.inc
    .686
    include \masm32\macros\timers.asm
;==============================================================================
    .data
        src   dd 64 dup(0)
        dest  dd 64 dup(0)
    .code
;==============================================================================

movememory proc uses esi edi to:dword,from:dword,amt:dword
    mov ecx,amt    ;returns ecx=0 if from<to, else ecx=-1.
    mov esi,from
    mov edi,to
    cmp esi,edi
    jc  short work_downwards
    rep movsb
    jmp short movememory_ret
work_downwards:
    dec ecx
    js  short movememory_ret
    mov al,[esi+ecx]
    mov [edi+ecx],al
    jmp short work_downwards
movememory_ret:
    ret
movememory endp

;==============================================================================
start:
;==============================================================================

    invoke Sleep, 4000

    invoke RtlMoveMemory, addr dest, addr src, 4*64
    invoke crt_memmove, addr dest, addr src, 4*64
    invoke crt_memcpy, addr dest, addr src, 4*64
    invoke movememory, addr dest, addr src, 4*64

    repeat 3

        counter_begin 1000, HIGH_PRIORITY_CLASS
            invoke RtlMoveMemory, addr dest, addr src, 4*64
        counter_end
        print str$(eax)," cycles, RtlMoveMemory",13,10

        counter_begin 1000, HIGH_PRIORITY_CLASS
            invoke crt_memmove, addr dest, addr src, 4*64
        counter_end
        print str$(eax)," cycles, memmove",13,10

        counter_begin 1000, HIGH_PRIORITY_CLASS
            invoke crt_memcpy, addr dest, addr src, 4*64
        counter_end
        print str$(eax)," cycles, memcpy",13,10

        counter_begin 1000, HIGH_PRIORITY_CLASS
            invoke movememory, addr dest, addr src, 4*64
        counter_end
        print str$(eax)," cycles, movememory",13,10,13,10

    endm

    inkey "Press any key to exit..."
    exit

;==============================================================================
end start
